import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterException;
import java.util.ArrayList;

import javax.print.Doc;
import javax.print.DocFlavor;
import javax.print.DocPrintJob;
import javax.print.PrintException;
import javax.print.PrintService;
import javax.print.PrintServiceLookup;
import javax.print.ServiceUI;
import javax.print.SimpleDoc;
import javax.print.attribute.DocAttributeSet;
import javax.print.attribute.HashDocAttributeSet;
import javax.print.attribute.HashPrintRequestAttributeSet;
import javax.print.attribute.PrintRequestAttributeSet;


public class TakanaTextPrint implements Printable {

	//^uŋ󂯂Xy[X
	static final int TAB_SPACE = 4;
	//
	String[] stringData;
	String fileName;
	//̃y[WƊey[W擪
	int page;
	int[] lineStart;
	int[] charStart;
	//̃wb_[ƃtb^[̉ʒu
	int headerXPos;
	int footerXPos;
	//̈ݒł̃y[W`FbNi̍ŏɂPxj
	boolean pageCheck;
	//
	public TakanaTextPrint(){
		stringData=new String[0];
		fileName="";
		//
		pageCheck=false;
	}
	//
	public void printString(String str,String file) throws PrintException {
		//f[^Zbg
		setStringData(str);
		fileName=file;
		//
		//IuWFNgMIME (Multipurpose Internet Mail Extensions) ^Cv̓
		DocFlavor flavor=DocFlavor.SERVICE_FORMATTED.PRINTABLE;
		//f[^Wuɗ^邽߂̃C^[tF[X
		DocAttributeSet das=new HashDocAttributeSet();
		Doc doc=new SimpleDoc(this,flavor,das);
		//ǂ̂悤Ɉ邩
		PrintRequestAttributeSet pras=new HashPrintRequestAttributeSet();
		//ftHg̈T[rXiv^[EIuWFNgj擾
		PrintService defaultService=PrintServiceLookup.lookupDefaultPrintService();
		//̕^Cv (GIFȂ) ̑Zbg (ʂȂ) ł̈T|[gv^[̃Zbg
		PrintService[] printServices=PrintServiceLookup.lookupPrintServices(flavor,pras);
		//v^[I_CAO\
		PrintService service=ServiceUI.printDialog(null,200,200,printServices,defaultService,flavor,pras);
		//Wu쐬
		DocPrintJob job;
		if(service!=null){
			job=service.createPrintJob();
		}else{
			return;
		}
		//֘ÃCxg󂯎悤ɂ
		//job.addPrintJobListener(this);
		//i PrintException 𓊂邩j
		job.print(doc,pras);
	}
	//󂯎f[^Zbgi̍ŏɂj
	private void setStringData(String str){
		ArrayList<String> strArray=new ArrayList<String>();
		//
		int start=0;
		for(int s=0;s<str.length();s++){
			if(str.charAt(s)=='\n'){
				strArray.add(str.substring(start, s));
				start=s+1;
			}
		}
		if(start<str.length()){
			strArray.add(str.substring(start));
		}
		//
		stringData = new String[strArray.size()];
		strArray.toArray(stringData);
	}
	//
	public int print(Graphics g, PageFormat fmt, int index)
			throws PrinterException {
		//TCY𒲐
		g.setFont(new Font(null,Font.PLAIN,9));
		//̕Ɖs̍߂邽ߕKv
		FontMetrics metrics=g.getFontMetrics();
		//y[W`FbNĂȂ΂
		if(!pageCheck){
			chaeckPageAttribute(metrics,fmt);
			setHeaderFooterPos(metrics,fmt);
			//`FbNς݂ɂ
			pageCheck=true;
		}
		//
		if(index>=page){						//͈͊Õy[WȂANO_SUCH_PAGEԂ
			pageCheck=false;	//̏̈Iił͐VȏŃy[W`FbNj
			return NO_SUCH_PAGE;
		}else{									//͈͓̃y[WȂ`悵āAPAGE_EXISTSԂ
			//\ȍʒu
			int x=(int)fmt.getImageableX();
			int y=(int)fmt.getImageableY();
			g.translate(x,y);
			//wb_[
			g.drawString(fileName, headerXPos, metrics.getAscent());
			//̕\ʒu
			int px=0;
			int py=metrics.getHeight()+metrics.getAscent();		//wb_[̕󂯂
			//PÂʒuw肵ĕ`
			for(int l=lineStart[index];l<stringData.length;l++){
				//ŏ̍śAŝߓr̕炩Ȃ
				int s;
				if(l!=lineStart[index]){
					s=0;
				}else{
					s=charStart[index];
				}
				//
				for(int c=s;c<stringData[l].length();c++){
					//^ȕꍇ̓Xy[X󂯂
					int cw;
					if( (stringData[l].charAt(c))!='\t' ){
						cw=metrics.charWidth(stringData[l].charAt(c));
					}else{
						cw=TAB_SPACE*metrics.charWidth(' ');
					}
					//̏ꍇ͈\̈ł͂ݏoĂ͂Ȃ
					//̕Eɂ͂ݏoȂA̍sɂ
					if(px+cw>fmt.getImageableWidth()){
						px=0;
						py+=metrics.getHeight();
						//ɂ͂ݏoȂy[WI
						if(py>fmt.getImageableHeight()-metrics.getHeight()){		//tb^[̕󂯂
							//tb^[
							printFooter(g,fmt,metrics,index);
							return PAGE_EXISTS;
						}
					}
					//P`
					g.drawString(String.valueOf(stringData[l].charAt(c)),px,py);
					//\ʒu𕶎EɈړ
					px+=cw;
				}
				//s̍Ō̕܂ŕ`悵Is
				px=0;
				py+=metrics.getHeight();
				//ɂ͂ݏoȂy[WI
				if(py>fmt.getImageableHeight()-metrics.getHeight()){		//tb^[̕󂯂
					//tb^[
					printFooter(g,fmt,metrics,index);
					return PAGE_EXISTS;
				}
			}
			//tb^[
			printFooter(g,fmt,metrics,index);
			//Ō܂ŕ`悵Iy[WI
			return PAGE_EXISTS;
		}
	}
	//tb^[`
	private void printFooter(Graphics g, PageFormat fmt, FontMetrics metrics, int index){
		g.drawString("page "+(index+1)+"/"+page, footerXPos, (int)(fmt.getImageableHeight()-metrics.getDescent()));
	}
	//wb_[ƃtb^[̉ʒu߂i̍ŏɂPxj
	private void setHeaderFooterPos(FontMetrics metrics, PageFormat fmt){
		int hw=0;
		for(int h=0;h<fileName.length();h++){
			hw+=metrics.charWidth(fileName.charAt(h));
		}
		headerXPos=(int)( (fmt.getImageableWidth()-hw)/2 );
		//
		String fs="page "+page+"/"+page;
		int fw=0;
		for(int f=0;f<fs.length();f++){
			fw+=metrics.charWidth(fs.charAt(f));
		}
		footerXPos=(int)( (fmt.getImageableWidth()-fw)/2 );
	}
	//̈ݒŉy[WɂȂAey[W̐擪͂ǂɂȂ邩i̍ŏɂPxj
	private void chaeckPageAttribute(FontMetrics metrics, PageFormat fmt){
		ArrayList<Integer> lineArray=new ArrayList<Integer>();
		ArrayList<Integer> charArray=new ArrayList<Integer>();
		//̕\ʒu
		int px=0;
		int py=metrics.getHeight()+metrics.getAscent();		//wb_[̕󂯂
		//ŏ̃y[W
		lineArray.add(Integer.valueOf(0));
		charArray.add(Integer.valueOf(0));
		//PÂʒumFi`͂AŏŌ܂ŗăy[WmFj
		for(int l=0;l<stringData.length;l++){
			for(int c=0;c<stringData[l].length();c++){
				//^ȕꍇ̓Xy[X󂯂
				int cw;
				if( (stringData[l].charAt(c))!='\t' ){
					cw=metrics.charWidth(stringData[l].charAt(c));
				}else{
					cw=TAB_SPACE*metrics.charWidth(' ');
				}
				//̏ꍇ͈\̈ł͂ݏoĂ͂Ȃ
				//̕Eɂ͂ݏoȂA̍sɂ
				if(px+cw>fmt.getImageableWidth()){
					px=0;
					py+=metrics.getHeight();
					//ɂ͂ݏoȂ玟y[W
					if(py>fmt.getImageableHeight()-metrics.getHeight()){		//tb^[̕󂯂
						px=0;
						py=metrics.getHeight();
						//y[W̐擪i[
						lineArray.add(Integer.valueOf(l));
						charArray.add(Integer.valueOf(c));
					}
				}
				//ŕ`͂Ȃ
				//\ʒu𕶎EɈړiŉEɂ͂ݏo邱Ƃ͂܂j
				px+=cw;
			}
			//s̍Ō̕܂ŏIs
			px=0;
			py+=metrics.getHeight();
			//ɂ͂ݏoȂ玟y[W
			if(py>fmt.getImageableHeight()-metrics.getHeight()){		//tb^[̕󂯂
				px=0;
				py=metrics.getHeight();
				//ŏIsłȂ΁Ay[W̐擪i[iŏIsȂSďIj
				if(l!=stringData.length-1){
					lineArray.add(Integer.valueOf(l+1));
					charArray.add(Integer.valueOf(0));
				}
			}
		}
		//y[W`FbŇʂZbg
		page=lineArray.size();
		lineStart=new int[page];
		charStart=new int[page];
		for(int p=0;p<page;p++){
			lineStart[p]=((Integer)lineArray.get(p)).intValue();
			charStart[p]=((Integer)charArray.get(p)).intValue();
		}
	}
}
